/*
 * yahoo_search_api.js
 * Part of the Yahoo! Search Sidebar for Firefox
 * powered by Yahoo! Search web services (http://api.search.yahoo.com)
 * Written by Marc Abramowitz (http://marc.abramowitz.info)
 * Copyright (C) 2005 Yahoo! Inc.
 */

function Yahoo_Search() {}

Yahoo_Search.baseURL = function () {
  return "http://api.search.yahoo.com/WebSearchService/V1/";
}

Yahoo_Search.appid = function () {
  return "flock-search";
}

Yahoo_Search.baseArgs = function () {
  return "appid=" + this.appid();
}

Yahoo_Search.Results = function (query, callback) {
  dump("Yahoo!\n");
  var inst = this;
  var xmlUrl = this.baseURL() + "webSearch?" 
       + this.baseArgs()
       + "&query=" + query
       + "&zip=" 
       + "&start=1&results=5";
       + "&fr=flock-search";
  this.xmlhttp = new XMLHttpRequest();
  this.xmlhttp.onreadystatechange = function (aEvt) {
      if(inst.xmlhttp.readyState == 4) {
          // dump("\nRESPONSE\n" + inst.xmlhttp.responseText);
          try {
              if(inst.xmlhttp.status == 200 || inst.xmlhttp.status == 201) {
                 try {
                     //processor(listener, inst);
                     var rdf = Yahoo_Search.readXML(inst.xmlhttp.responseXML);
                     callback.FoundResults(rdf);
                 } catch(e) {
                     dump(e + " " + e.lineNumber+"\n");
                 }
              }
              else {
                  var faultString = inst.xmlhttp.responseText;
                  // listener.onFault(faultString);
              }
          } catch(e) {
              dump(e + " " + e.fileName + " " + e.lineNumber + "\n");
              //listener.onError(inst.ERROR_PARSER);
          }
      }
  };

  this.xmlhttp.open("GET", xmlUrl, true);
  this.xmlhttp.send(null);
  // return this.readXML(xmlhttp.responseXML);
  dump("sent!\n");
}

Yahoo_Search.readXML = function (xmlDoc) {
  try {
    var resultSet = xmlDoc.getElementsByTagName("ResultSet")[0];                                                              
    var totalResultsAvailable = parseInt(resultSet.getAttribute("totalResultsAvailable"));  
    var totalResultsReturned = parseInt(resultSet.getAttribute("totalResultsReturned"));                                      
    var firstResultPosition = parseInt(resultSet.getAttribute("firstResultPosition"));                                        
    var start = firstResultPosition;                                                                                          
    var end = firstResultPosition + totalResultsReturned - 1;                                                                 
    var results = xmlDoc.getElementsByTagName("Result"); 

    // Create an in-memory datasource
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
        .getService(Components.interfaces.nsIRDFService);
    var rdf = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource);
    var rdfContainerUtils = Components.classes["@mozilla.org/rdf/container-utils;1"]
        .createInstance(Components.interfaces.nsIRDFContainerUtils);
    // Fill it with the results
    var container = rdfContainerUtils.MakeSeq(rdf, rdfService.GetResource("urn:flock:search:web"));
    for (var i = 0; i < results.length; i++) { 

        var result = results[i];                                                                                                
        var title = result.getElementsByTagName('Title')[0].firstChild.nodeValue;
        var clickUrl = result.getElementsByTagName('ClickUrl')[0].firstChild.nodeValue;
        var url = result.getElementsByTagName('Url')[0].firstChild.nodeValue;
        dump (title+"\n");
        dump (clickUrl+"\n");
        dump (url+"\n");

        var subject = rdfService.GetResource(url);

        var predicate = rdfService.GetResource("http://home.netscape.com/NC-rdf#Name");
        var name = rdfService.GetLiteral(title);                
        rdf.Assert(subject, predicate, name, true);

        var predicate = rdfService.GetResource("http://home.netscape.com/NC-rdf#URL");
        var name = rdfService.GetLiteral(url);
        rdf.Assert(subject, predicate, name, true);

        container.AppendElement(subject);
    }

    return rdf;
  } catch(exception) {
    alert('Exception occurred while reading XML (i=' + i + '; start=' + start + ';end=' + end + '): ' + exception);
  }
}
