var lucenePanel = {};
lucenePanel.mRef = "urn:flock:search:results";
lucenePanel.mDS = null;

lucenePanel.load = function() {
    var location = window.location.toString();
    if(location.match(/mode=history/)) {
        this.mRef = "urn:flock:search:history";
    }
    else if(location.match(/mode=favorites/)) {
        this.mRef = "urn:flock:search:favorites";
    }
    document.getElementById("searchBox").focus();
}

lucenePanel.unload = function() {
    lucenePanel.removeDataSourceIfNecessary();
}

lucenePanel.removeDataSourceIfNecessary = function() {
    var luceneTree = document.getElementById("luceneTree");
    if(lucenePanel.mDS) {
        luceneTree.database.RemoveDataSource(lucenePanel.mDS);
        lucenePanel.mDS = null;
    }
}

lucenePanel.search = function(aQuery) {

    var callback =  {
        FoundResults: function (aCount, aResults) {
            var luceneTree = document.getElementById("luceneTree");
            lucenePanel.removeDataSourceIfNecessary();
            lucenePanel.mDS = aResults;
            luceneTree.ref = lucenePanel.mRef;
            luceneTree.database.AddDataSource(lucenePanel.mDS);
            luceneTree.builder.rebuild();
            var noResults = document.getElementById("noResults");
            if(aCount==0) {
                noResults.removeAttribute("hidden");
            }
            else {
                noResults.setAttribute("hidden", true);
            }
        },
        onResult: function (aData) {
        },
        onError: function (aError) {
        }
    }
    var luceneIndexer = Components.classes['@flock.com/lucene/indexer;1'].
                            getService(Components.interfaces.flockILuceneIndexer);
    luceneIndexer.Search(aQuery, 100, callback);
}

lucenePanel.openUrl = function(aEvent) {
    var luceneTree = document.getElementById("luceneTree");
    var currentIndex = luceneTree.currentIndex;     
 
    var builder = luceneTree.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
    var url = builder.getResourceAtIndex(currentIndex).ValueUTF8;

    var where = whereToOpenLink(aEvent);
    openUILinkIn(url, where);
}

