// vim: foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var shelfBottomRdfObserver = {/*{{{*/
    onAssert            : function(ds, source, predicate, target){
                             shelfRefreshBottomLine();
                          },
    onUnassert          : function(ds, source, predicate, target){
                             shelfRefreshBottomLine();
                          },
    onChange            : function(ds, source, predicate, oldTarget, newTarget){
                             shelfRefreshBottomLine();
                          },
    onMove              : function(ds, oldSource, newSource, predicate, target){},
    onBeginUpdateBatch  : function(ds){},
    onEndUpdateBatch    : function(ds){}
}/*}}}*/

function initShelfBottomLine(){/*{{{*/
    XXX('INIT BOTTOM SHELF');
   shelfRefreshBottomLine();
   flock.shelf.service.AddObserver(shelfBottomRdfObserver);
}/*}}}*/

function closeShelfBottomLine(){/*{{{*/
    XXX('CLOSE BOTTOM SHELF');
    flock.shelf.service.RemoveObserver(shelfBottomRdfObserver);
}/*}}}*/

window.addEventListener("load", initShelfBottomLine, false);
window.addEventListener("unload", closeShelfBottomLine, false);

