function $(aID) { return document.getElementById(aID); }

var firstRunWizardStart = {};

firstRunWizardStart.load = function() {
    this.mWizards = window.arguments[0].mWizards;
    this.mWizardName2Wizard = {};
    for(var i=0;i<this.mWizards.length;++i) {
        var wiz = this.mWizards[i];
        this.mWizardName2Wizard[wiz.wizardName] = wiz;
    }
    this.buildList();
}

firstRunWizardStart.unload = function() {
}

firstRunWizardStart.skipToLastPage = function(aEvent) {
    firstRunWizardStart.mPreviousPage = $("firstRunWizardStart").currentPage.pageid;
    window.arguments[0].close();        
}

firstRunWizardStart.returnToPreviousPage = function() {
    $("firstRunWizardStart").goTo(this.mPreviousPage);
}

firstRunWizardStart.buildList = function() {
    var listItemTemplate = $("wizardListItemTemplate");
    var list = $("wizardList");
    for(var i=0;i<this.mWizards.length;++i) {
        var page = this.mWizards[i];
        //if(page.wizardEnabled && !page.internal) {
        if(!page.internal) {
            var item = listItemTemplate.cloneNode(true);
            list.appendChild(item);
            item.removeAttribute("hidden");
            var checkbox = item.firstChild;
            checkbox.setAttribute("label", page.wizardLabel);
            checkbox.setAttribute("value", page.wizardName);
            checkbox.checked = page.wizardEnabled;

            var setEnabled = function(aEvent) {
                var cb = aEvent.target;
                var page = firstRunWizardStart.mWizardName2Wizard[cb.getAttribute("value")];
                page.wizardEnabled = cb.checked;
            }
            checkbox.addEventListener('command', setEnabled, false);
        }
    }
}

firstRunWizardStart.startPage = {};
firstRunWizardStart.startPage.show = function() {
    document.getAnonymousElementByAttribute($("firstRunWizardStart"), "class", "wizard-buttons")
        .setAttribute("hidden", true); 
}

firstRunWizardStart.configPage = {};
firstRunWizardStart.configPage.show = function() {
    if(!this.mInit) {
        this.mInit = true;
        $("firstRunWizardStart").getButton("cancel")
                .addEventListener('command', firstRunWizardStart.skipToLastPage, false);
    }
    document.getAnonymousElementByAttribute($("firstRunWizardStart"), "class", "wizard-buttons")
        .removeAttribute("hidden");
}

firstRunWizardStart.endPage = {};
firstRunWizardStart.endPage.show = function() {
    document.getAnonymousElementByAttribute($("firstRunWizardStart"), "class", "wizard-buttons")
        .setAttribute("hidden", true); 
}

